package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.fd.DmCzjbb;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.kc.ImCkwpkwp;
import com.dsic.gj_erp.bean.kc.SlKc;
import com.dsic.gj_erp.bean.pgd.PgdPwjh;
import com.dsic.gj_erp.bean.pgd.PgdSljh;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.mapper.kc.ImCkwpkwpMapper;
import com.dsic.gj_erp.service.fd.DmCzjbbService;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import com.dsic.gj_erp.service.kc.ImCkwpkwpService;
import com.dsic.gj_erp.service.pgd.PgdSljhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdSljh")
public class PgdSljhController {
    
    
    @Autowired
    PgdSljhService pgdSljhService;

    @Autowired
    DmYdjhService dmYdjhService;


    @Autowired
    ImCkwpkwpMapper imCkwpkwpMapper;
    @Autowired
    ImCkwpkwpService  imCkwpkwpService;

    @Autowired
    DmCzjbbService dmCzjbbService;


    @PostMapping("/getKcAndSljh")
    @ResponseBody
    public ResultBean getKcAndSljh(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {


        // 查询库存
        List<SlKc> slkcs = imCkwpkwpMapper.slxxKcList(map);

        QueryWrapper<DmYdjh> qw =new QueryWrapper<>();
        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"dc_ch",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"dc_pl",(String)map.get("pl"));
        // 库存标识 不等于 01 没有匹配上



            if(map.get("rqopt").equals("01")){
                qw.ne("isnull(ZT,'')","11");
            }else if(map.get("rqopt").equals("02")) {
                qw.eq("isnull(ZT,'')","11");
            }

        List<DmYdjh> ydjhs = dmYdjhService.list(qw);
        // 查询上料计划
        Map retrunMap =new HashMap();
        retrunMap.put("slkcs",slkcs);
        retrunMap.put("ydjhs",ydjhs);
        return new ResultBean(retrunMap);

    }


    @PostMapping("/getydjhByid")
    @ResponseBody
    public ResultBean getydjhByid(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {


        // 查询库存
        DmYdjh id = dmYdjhService.getById((String)map.get("id"));
        return new ResultBean(id);

    }

    @PostMapping("kcAdnSlBd")
    @ResponseBody
    public ResultBean kcAdnSlBd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {

        String str= JSON.toJSONString(map.get("data1"));
        List<SlKc>  slKcs= JSONObject.parseArray(str, SlKc.class);
        String str1= JSON.toJSONString(map.get("data2"));
        List<DmYdjh>ydjhs= JSONObject.parseArray(str1, DmYdjh.class);

        List<DmCzjbb> czList = dmCzjbbService.list();
        List<DmYdjh>ydupList=new ArrayList<>();
        List<SlKc>ckupList=new ArrayList<>();
        // 进行比对
        for(SlKc slKc :slKcs){
            // 获取船级社
            String cjs="";
            DmCzjbb dmCzjbb = czList.stream().filter(fst -> fst.getCzbh().equalsIgnoreCase(slKc.getDCCH())).findFirst().orElse(null);

            if(null!=dmCzjbb){
                cjs=dmCzjbb.getCjs();
            }
            String cjs1=cjs;
            DmYdjh dmYdjh = ydjhs.stream()
                .filter(fst -> fst.getDcCh().equalsIgnoreCase(slKc.getDCCH())
                    && fst.getWpgg().equalsIgnoreCase(slKc.getWPGG())
                    && (fst.getWpxh().equalsIgnoreCase(slKc.getWPXH())
                    || (cjs1 + fst.getWpxh()).equalsIgnoreCase(slKc.getWPXH()))
                    )
                .findFirst()
                .orElse(null);

            if(null!=dmYdjh){
                System.out.println("slKc = " + slKc);
                dmYdjh.setSlkcdw(slKc.getKWH());
                System.out.println(slKc.getCFCS1()+dmYdjh.getId());
                dmYdjh.setSlcs(slKc.getCFCS1());
                dmYdjh.setSlxhth(slKc.getGCDDH());
                dmYdjh.setSlhth(slKc.getDcFd());
                dmYdjh.setSlwlh(slKc.getWPH());
                dmYdjh.setZt("11");
                dmYdjh.setKcbs("01");

//                ImCkwpkwp imCkwpkwp =new ImCkwpkwp();
//                imCkwpkwp.setCkh(slKc.getCKH());
//                imCkwpkwp.setWph(slKc.getWPH());
//                imCkwpkwp.setKwh(slKc.getKWH());
//                imCkwpkwp.setNbsbm(slKc.getNBSBM());
//                imCkwpkwp.setYdid(dmYdjh.getId());
//                imCkwpkwp.setZych(dmYdjh.getDcCh());
//                imCkwpkwp.setZypl(dmYdjh.getDcPl());
//                imCkwpkwp.setZylx(dmYdjh.getZl());
//                imCkwpkwp.setSldw(dmYdjh.getKw());
                ydupList.add(dmYdjh);
               // ckupList.add(imCkwpkwp);


                slKc.setZYCH(dmYdjh.getDcCh());
                slKc.setZYPL(dmYdjh.getDcPl());
                slKc.setZYLX(dmYdjh.getZl());
                slKc.setSLDW(dmYdjh.getKw());
                slKc.setYdid(dmYdjh.getId());
                ydjhs.remove(dmYdjh); // 从列表中移除找到的元素
                ckupList.add(slKc);
            }
            // 填写  库存垛位 kwh  层数  cfcs1  小合同号 gcddh    合同工 dc_fd   物料号 wph    炉批号  lph

        }
        Map retrunMap =new HashMap();
        retrunMap.put("slkcs",ckupList);
        retrunMap.put("ydjhs",ydupList);
        return new ResultBean(retrunMap);
    }

    @PostMapping("kcAdnSlZx")
    @ResponseBody
    public void kcAdnSlZx(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {

        String str= JSON.toJSONString(map.get("data1"));
        List<SlKc>  slKcs= JSONObject.parseArray(str, SlKc.class);
        String str1= JSON.toJSONString(map.get("data2"));
        List<DmYdjh>ydjhs= JSONObject.parseArray(str1, DmYdjh.class);


        List<DmYdjh>ydupList=new ArrayList<>();
        List<ImCkwpkwp>ckupList=new ArrayList<>();
        //String id = syService.f_getpjh("DM", "SYSTEM", "YLBH");
        for(SlKc slKc :slKcs){
            ImCkwpkwp imCkwpkwp =new ImCkwpkwp();
                imCkwpkwp.setCkh(slKc.getCKH());
                imCkwpkwp.setWph(slKc.getWPH());
                imCkwpkwp.setKwh(slKc.getKWH());
                imCkwpkwp.setNbsbm(slKc.getNBSBM());
                imCkwpkwp.setYdid(slKc.getYdid());
                imCkwpkwp.setZych(slKc.getZYCH());
                imCkwpkwp.setZypl(slKc.getZYPL());
                imCkwpkwp.setZylx(slKc.getZYLX());
                imCkwpkwp.setSldw(slKc.getSLDW());
            ckupList.add(imCkwpkwp);
        }

        imCkwpkwpService.updateBatchByMultiId(ckupList);
        dmYdjhService.updateBatchById(ydjhs);

//

    }


    @PostMapping("/saveSljhPg")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPg(HttpServletRequest req, @RequestBody List<PgdSljh> list) throws Exception, CustomException {
        pgdSljhService.saveSljhPg(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhPgBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgBack(HttpServletRequest req, @RequestBody List<PgdSljh> list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgBack(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgdXd(HttpServletRequest req, @RequestBody List<PgdSljh> list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgdXdBack(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/saveSljhPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhPgdFk(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
        pgdSljhService.saveSljhPgdFk(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveSljhFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveSljhFk(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
        pgdSljhService.saveSljhFk(list,req);
        return new ResultBean();
    }



//    @PostMapping("/getKcAndSljh")
//    @ResponseBody
//    @AuthFunction
//    public ResultBean getKcAndSljh(HttpServletRequest req, @RequestBody List<PgdSljh>list) throws Exception, CustomException {
//        pgdSljhService.getKcAndSljh(list,req);
//        return new ResultBean();
//    }

}

