package com.dsic.gj_erp.datasync;

import lombok.Getter;
import lombok.Setter;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

@Getter
@Setter
//@Component
//@ConfigurationProperties(prefix = "data-sync",ignoreInvalidFields = true)
public class Config {

    private String host;
    private String port;
    private Map<String,String> uri;

    private Integer tokenExpTime=4*60*60;//token超时时长,默认4个小时

    //发送请求需要携带head名称
    private String tokenName;
    private String typeName;
    private String authType;
    private String channelCodeName;
    private String channelCode;
    private String _channelCodeName;
    private String _channelCode;
    private String userCodeName;
    private String xAuthTokenName;

    //登录账号密码,密码采用md5加密
    private String account;
    private String pwd;//已加密,aff462d5872e714dadf9f17109527406

    public String getRequestUrl(String name){
        return host+":"+port+uri.get(name);
    }

    public Map<String,Object> getLoginFormData(){
        return new HashMap<String,Object>(){{
            put("usercode",account);
            put("passwd",pwd);
        }};
    }
}
