package com.dsic.gj_erp.pc.service;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmSygd;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.DmSygdMxLj;
import com.dsic.gj_erp.bean.jhgk.DmYdjhxf;
import com.dsic.gj_erp.mapper.jhgk.DmSygdxqMapper;
import com.dsic.gj_erp.pc.Manager;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.jhgk.DmSygdService;
import com.dsic.gj_erp.service.jhgk.impl.DmSygdMxLjServiceImpl;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
@AllArgsConstructor
public class 三月滚动接口 {

    private final DmSygdxqMapper sygdxqMapper;
    private final DmSygdMxLjServiceImpl ljService;
    private final DmSygdMxService sygdMxService;
    private final DmSygdService sygdService;



    @Transactional
    public ResultBean 生成三月滚动(String begin, String end) {
        //清理历史数据
        ljService.remove(new QueryWrapper<DmSygdMxLj>().between("xzglxq", begin, end));
        sygdMxService.remove(new QueryWrapper<DmSygdMx>().between("jssj", begin, end));
        sygdService.remove(new QueryWrapper<DmSygd>().between("sl_sj", begin, end));

        //开始汇总
        List<DmSygdMxLj> ljList = sygdxqMapper.getSygdLjMx(begin,end);

        if (ljList.size() < 1) {
            return new ResultBean(false, 1, "请先导入" + begin + " ~ " + end + "分段钢料需求！");
        }

        //2.根据
        List<DmSygdMx> mxList = ljList.stream().map(DmSygdMx::ofWithDmSygdMxlj).collect(Collectors.toList());

        Map<String, List<DmSygdMx>> collect = mxList.stream().collect(Collectors.groupingBy(item -> item.getDcCh() + item.getDcPl() + item.getTzbh()));

        DateTime from = DateUtil.parse(begin, "yyyy/MM/dd");
        DateTime to = DateUtil.parse(end, "yyyy/MM/dd");

        Manager.资源池.values().parallelStream()
                .filter(_资源->DateUtil.isIn(_资源.get_date(),from,to))
                .forEach(_资源->{_资源.get工序产能MAP().values().forEach(_工序产能->{
                    _工序产能.get设备().values().forEach(_设备->{
                        _设备.get资源占用图表().parallelStream().forEach(_bom->{
                            List<DmSygdMx> dmSygdMxes = collect.get(_bom.getDcch() + _bom.getPl() + _bom.getTzbh());
                            for (DmSygdMx mx:dmSygdMxes){
                                mx.更新排产信息(_工序产能.get工序(),_资源.getDate());
                            }
                        });
                    });
                });
            });

        sygdMxService.saveBatch(mxList,500);

        ljList.forEach(lj-> mxList.forEach(mx->{
            if (lj.getDcch().equals(mx.getDcCh())
                    &&lj.getPl().equals(mx.getDcPl())
                    && (StrUtil.isBlank(lj.getTzbh())||lj.getTzbh().equals(mx.getTzbh()))){
                lj.setParentId(mx.getId());
            }
        }));
        ljService.saveBatch(ljList,500);

        List<DmYdjhxf> list= sygdMxService.tqSygd1(begin,end);
        ResultBean r = new ResultBean(list);
        return r;
    }
}
