package com.dsic.gj_erp.pc.service;

import com.dsic.gj_erp.pc.设备产能;
import lombok.AllArgsConstructor;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
@AllArgsConstructor
public class 设备产能接口 {

    private static final String KEY="sbcn";

    private final RedisTemplate<String,Object> redisTemplate;

    @CachePut(cacheNames = {KEY},key = "#sbcn.getCode()")
    public Object save(设备产能 sbcn){
        return sbcn;
    }

    @Cacheable(value = {KEY},key = "#code")
    public Object get(String code){
        return new HashMap<>();
    }

    @CacheEvict(value = {KEY}, key="#code")
    public Object remove(String code){
        return new HashMap<>();
    }

    public List<设备产能> get(){
        Set<String> keys = redisTemplate.keys(KEY+"::*");
        List<设备产能> list=new ArrayList<>();
        if (keys==null){
            return new ArrayList<>();
        }
        for (String key:keys){
            设备产能 _设备产能= (设备产能) redisTemplate.opsForValue().get(key);
            list.add(_设备产能);
        }
        return list;
    }
}
