package com.dsic.gj_erp.service.pgd.impl;

import cn.hutool.core.date.DateUtil;
import com.dsic.gj_erp.bean.pgd.PgdPwjh;
import com.dsic.gj_erp.bean.pgd.PgdQgjh;
import com.dsic.gj_erp.bean.pgd.PgdSljh;
import com.dsic.gj_erp.mapper.pgd.PgdQgjhMapper;
import com.dsic.gj_erp.service.pgd.PgdQgjhService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@Service
public class PgdQgjhServiceImpl extends ServiceImpl<PgdQgjhMapper, PgdQgjh> implements PgdQgjhService {







    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveQgjhPg(List<PgdQgjh> sljhs, HttpServletRequest request) {

        List<PgdQgjh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdQgjh e= new PgdQgjh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("02");
            e.setScdw(f.getScdw());
            e.setScry(f.getScry());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }


    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveQgjhPgBack(List<PgdQgjh> sljhs, HttpServletRequest request) {

        List<PgdQgjh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdQgjh e= new PgdQgjh();
            e.setXfry("");
            e.setXfrq("");
            e.setZt("01");
            e.setScdw("");
            e.setScry("");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }



    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveQgPgdXd(List<PgdQgjh> qgjhs, HttpServletRequest request) {
        List<PgdQgjh>ups= new ArrayList<>();
        qgjhs.forEach(f->{
            PgdQgjh e= new PgdQgjh();
            e.setJsry((String) request.getAttribute("yhms"));
            e.setJsrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("03");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveQgPgdFk(List<PgdQgjh> qgjhs, HttpServletRequest request) {
        List<PgdQgjh>ups= new ArrayList<>();
//        qgjhs.forEach(f->{
//            PgdQgjh e= new PgdQgjh();
//            e.setFkry((String) request.getAttribute("yhms"));
//            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
//            e.setZt("09");
//            e.setFkyy(f.getFkyy());
//            e.setId(f.getId());
//            ups.add(e);
//        });
        this.updateBatchById(ups);
    }

    @Override
    public void saveQgdFk(List<PgdQgjh> qgjhs, HttpServletRequest request) {
        List<PgdQgjh>ups= new ArrayList<>();
        qgjhs.forEach(f->{
            PgdQgjh e= new PgdQgjh();
//              e.setQgry(f.getQgry());
//             e.setQgksrq(f.getQgksrq());
//             e.setQgjsrq(f.getQgjsrq());
            e.setFkry((String) request.getAttribute("yhms"));
            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("04");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveQgPgdXdBack(List<PgdQgjh> qgjhs, HttpServletRequest request) {
        List<PgdQgjh>ups= new ArrayList<>();
        qgjhs.forEach(f->{
            PgdQgjh e= new PgdQgjh();
            e.setJsrq("");
            e.setJsrq("");
            if(f.getZt().equals("03")){
                e.setZt("02");
            }
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    /**
     *  切割去曲面 //todo
     * @param qgjhs
     * @param request
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void qgToQm(List<PgdQgjh> qgjhs, HttpServletRequest request) {

    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void qgToPk(List<PgdQgjh> qgjhs, HttpServletRequest request) {
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void qgToDm(List<PgdQgjh> qgjhs, HttpServletRequest request) {
    }
}
