package com.dsic.gj_erp.wsclient;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NonNull;
import lombok.Setter;

@Getter
@Setter
public class Message {
    private int code;
    private Msg msg;
    @JSONField(serialize = false)
    private CodeEnum codeEx;
    @JSONField(serialize = false)
    private Instructions instructions;

    public static Message reg(String id){
        Message message = new Message();
        message.setCode(CodeEnum.REG.getCode());
        message.setMsg(Msg.reg(id));
        message.formatCodeToEnum(CodeEnum.REG.getCode());
        return message;
    }

    public static Message heart(String id){
        Message message = new Message();
        message.setCode(CodeEnum.HEART.getCode());
        message.setMsg(Msg.reg(id));
        message.formatCodeToEnum(CodeEnum.HEART.getCode());
        return message;
    }

    public static Message result(String id,String result){
        Message message = new Message();
        message.setCode(CodeEnum.RESULT.getCode());
        message.setMsg(Msg.success(id,result));
        return message;
    }

    public void formatInstructions(){
        if (this.getCodeEx()==CodeEnum.ZX){
            Instructions.valueOf(this.msg.getResult());
        }
    }

    public void formatCodeToEnum(@NonNull int code){
        for (CodeEnum e:CodeEnum.values()){
            if (e.getCode()==code){
                this.codeEx=e;
            }
        }
    }

    public CodeEnum getEnumByCode(@NonNull int code){
        for (CodeEnum e:CodeEnum.values()){
            if (e.getCode()==code){
                return e;
            }
        }
        return null;
    }

    @Getter
    @AllArgsConstructor
    public enum CodeEnum{
        REG(9000),
        ZX(3000),
        RESULT(9002),
        HEART(9003),
        ;

        private final int code;
    }

    public enum Instructions{
        大船大船,开始派工,开始报工,确认完毕
    }

    @Getter
    @Setter
    public static class Msg{
        private String erpId;
        private String orderNumber;
        private String actionType;
        private String time;
        private String deviceId;
        private String result;

        private static Msg reg(String id){
            Msg msg = new Msg();
            msg.setErpId(id);
            return msg;
        }

        private static Msg success(String id,String code){
            Msg msg = new Msg();
            msg.setErpId(id);
            msg.setResult(code);
            return msg;
        }
    }

    public JSONObject toJson(){
        return (JSONObject) JSONObject.toJSON(this);
    }

    @Override
    public String toString(){
        return JSONObject.toJSONString(this);
    }
}
